
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NotificationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.create(
            {
                id: data.id || undefined,
        
        channel: data.channel
        ||
        null
            ,
            
        template_type: data.template_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        scheduled_at: data.scheduled_at
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        to_address: data.to_address
        ||
        null
            ,
            
        subject: data.subject
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        provider_message_reference: data.provider_message_reference
        ||
        null
            ,
            
        error_message: data.error_message
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await notifications.setHotel( data.hotel || null, {
            transaction,
        });
        
        await notifications.setReservation( data.reservation || null, {
            transaction,
        });
        
        await notifications.setGuest( data.guest || null, {
            transaction,
        });
        
        await notifications.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return notifications;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const notificationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                channel: item.channel
            ||
            null
            ,
            
                template_type: item.template_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                scheduled_at: item.scheduled_at
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                to_address: item.to_address
            ||
            null
            ,
            
                subject: item.subject
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                provider_message_reference: item.provider_message_reference
            ||
            null
            ,
            
                error_message: item.error_message
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const notifications = await db.notifications.bulkCreate(notificationsData, { transaction });

        // For each item created, replace relation files
        

        return notifications;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const notifications = await db.notifications.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.channel !== undefined) updatePayload.channel = data.channel;
        
        
        if (data.template_type !== undefined) updatePayload.template_type = data.template_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.scheduled_at !== undefined) updatePayload.scheduled_at = data.scheduled_at;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.to_address !== undefined) updatePayload.to_address = data.to_address;
        
        
        if (data.subject !== undefined) updatePayload.subject = data.subject;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.provider_message_reference !== undefined) updatePayload.provider_message_reference = data.provider_message_reference;
        
        
        if (data.error_message !== undefined) updatePayload.error_message = data.error_message;
        
        
        updatePayload.updatedById = currentUser.id;

        await notifications.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await notifications.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        
        if (data.reservation !== undefined) {
            await notifications.setReservation(
              
              data.reservation,
              
              { transaction }
            );
        }
        
        if (data.guest !== undefined) {
            await notifications.setGuest(
              
              data.guest,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await notifications.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return notifications;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of notifications) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of notifications) {
                await record.destroy({transaction});
            }
        });


        return notifications;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findByPk(id, options);

        await notifications.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await notifications.destroy({
            transaction
        });

        return notifications;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findOne(
            { where },
            { transaction },
        );

        if (!notifications) {
            return notifications;
        }

        const output = notifications.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.hotel = await notifications.getHotel({
            transaction
        });
        
        
        output.reservation = await notifications.getReservation({
            transaction
        });
        
        
        output.guest = await notifications.getGuest({
            transaction
        });
        
        
        output.organizations = await notifications.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.reservations,
        as: 'reservation',
        
        where: filter.reservation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reservation.split('|').map(term => Utils.uuid(term)) } },
            {
              reservation_number: {
                [Op.or]: filter.reservation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.guests,
        as: 'guest',
        
        where: filter.guest ? {
          [Op.or]: [
            { id: { [Op.in]: filter.guest.split('|').map(term => Utils.uuid(term)) } },
            {
              last_name: {
                [Op.or]: filter.guest.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.to_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'to_address',
                        filter.to_address,
                    ),
                };
            }
            
            if (filter.subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'subject',
                        filter.subject,
                    ),
                };
            }
            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'body',
                        filter.body,
                    ),
                };
            }
            
            if (filter.provider_message_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'provider_message_reference',
                        filter.provider_message_reference,
                    ),
                };
            }
            
            if (filter.error_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'error_message',
                        filter.error_message,
                    ),
                };
            }
            

            
            

            
            if (filter.scheduled_atRange) {
                const [start, end] = filter.scheduled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_at: {
                    ...where.scheduled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.channel) {
                where = {
                    ...where,
                channel: filter.channel,
            };
            }
            
            if (filter.template_type) {
                where = {
                    ...where,
                template_type: filter.template_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.notifications.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'notifications',
                        'subject',
                        query,
                    ),
                ],
            };
        }

        const records = await db.notifications.findAll({
            attributes: [ 'id', 'subject' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['subject', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.subject,
        }));
    }

    
};

